// Copyright 2015 The Vanadium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package principal

import (
	"encoding/base64"
	"v.io/v23/security"
)

func ConvertBlessingsToHandle(blessings security.Blessings, handle int32) *BlessingsHandle {
	encoded, err := EncodePublicKey(blessings.PublicKey())
	if err != nil {
		panic(err)
	}
	return &BlessingsHandle{
		Handle:    handle,
		PublicKey: encoded,
	}
}

func EncodePublicKey(key security.PublicKey) (string, error) {
	bytes, err := key.MarshalBinary()
	if err != nil {
		return "", err
	}
	return base64.StdEncoding.EncodeToString(bytes), nil
}
